// DigiClyd.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "LineClyde.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HINSTANCE g_hInstance = NULL;

static AFX_EXTENSION_MODULE DigiClydDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("DIGICLYD.DLL Initializing!\n");
		
		g_hInstance = hInstance;

		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(DigiClydDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(DigiClydDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("DIGICLYD.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(DigiClydDLL);
	}
	return 1;   // ok
}

BOOL APIENTRY NewObj(CConfigObject const ** const ppObj, CString const & strName, HKEY const hKeyRoot, CString const & strRegPath, CConfigObject const * const pParent)
{

    BOOL fSuccess = FALSE;

    TRACE("DigiClyd.DLL: NewObj(%s)\n", (LPCTSTR)strName);


    try
    {

		AffirmThrow(ppObj != NULL);
#if defined(_DEBUG)
		if (*ppObj != NULL) TRACE("*ppObj != NULL\n");
#endif

		CString strLineClyde( _T("Line"));
		strLineClyde += DXB_REGVAL_OPTION_ENUM_CLYDE;
		CString strLineSnyc570( _T("Line"));
		strLineSnyc570 += DXB_REGVAL_OPTION_ENUM_SYNC570;
		CConfigObject * pNewObj = NULL;
		if ((strName == strLineClyde) || (strName == strLineSnyc570))
			pNewObj = new CLineClyde(hKeyRoot,strRegPath,pParent);
		else
			AffirmThrow(FALSE);
		AffirmThrow(pNewObj != NULL);
		*ppObj  = pNewObj;
		fSuccess = TRUE;
	}
	catch (CAffirmException ae)
	{
	}

	return fSuccess;
}

void APIENTRY DeleteObj(CConfigObject const ** const ppObj)
{

	TRACE("DIGICLYD.DLL: DeleteObj()\n");

	try
	{
		AffirmThrow(ppObj != NULL);
		AffirmThrow(*ppObj != NULL);

		delete *ppObj;
		*ppObj = NULL;
	}
	catch (CAffirmException ae)
	{
	}

	return;
}
